<?php

namespace Classifieds\Subcategory\Seeders;

use Illuminate\Support\Facades\DB;
use Illuminate\Database\Seeder;

class SubcategoryTableSeeder extends Seeder
{
    public function run()
    {
        DB::table('classifieds_subcategory_subcategories')->insert([
            
        ]);

        DB::table('permissions')->insert([
            [
                'slug'      => 'classifieds.subcategory.subcategory.view',
                'name'      => 'View Subcategory',
            ],
            [
                'slug'      => 'classifieds.subcategory.subcategory.create',
                'name'      => 'Create Subcategory',
            ],
            [
                'slug'      => 'classifieds.subcategory.subcategory.edit',
                'name'      => 'Update Subcategory',
            ],
            [
                'slug'      => 'classifieds.subcategory.subcategory.delete',
                'name'      => 'Delete Subcategory',
            ],
            
                        [
                'slug'      => 'classifieds.subcategory.subcategory.verify',
                'name'      => 'Verify Subcategory',
            ],
            [
                'slug'      => 'classifieds.subcategory.subcategory.approve',
                'name'      => 'Approve Subcategory',
            ],
            [
                'slug'      => 'classifieds.subcategory.subcategory.publish',
                'name'      => 'Publish Subcategory',
            ],
            [
                'slug'      => 'classifieds.subcategory.subcategory.unpublish',
                'name'      => 'Unpublish Subcategory',
            ],
            [
                'slug'      => 'classifieds.subcategory.subcategory.cancel',
                'name'      => 'Cancel Subcategory',
            ],
            [
                'slug'      => 'classifieds.subcategory.subcategory.archive',
                'name'      => 'Archive Subcategory',
            ],
            
                    ]);

        DB::table('menus')->insert([
        
            // Admin menu
            [
                'parent_id'   => 1,
                'key'         => null,
                'url'         => 'admin/subcategory/subcategory',
                'name'        => 'Subcategory',
                'description' => null,
                'icon'        => 'las la-scroll',
                'target'      => null,
                'order'       => 190,
                'status'      => 1,
            ],
            
            // User menu.
            [
                'parent_id'   => 2,
                'key'         => null,
                'url'         => 'user/subcategory/subcategory',
                'name'        => 'Subcategory',
                'description' => null,
                'icon'        => 'las la-scroll',
                'target'      => null,
                'order'       => 190,
                'status'      => 1,
            ],

            // Public menu.
            [
                'parent_id'   => 3,
                'key'         => null,
                'url'         => 'subcategory',
                'name'        => 'Subcategory',
                'description' => null,
                'icon'        => 'las la-scroll,
                'target'      => null,
                'order'       => 190,
                'status'      => 1,
            ],

        ]);

        DB::table('settings')->insert([
            // Uncomment  and edit this section for entering value to settings table.
            /*
            [
                'pacakge'   => 'Subcategory',
                'module'    => 'Subcategory',
                'user_type' => null,
                'user_id'   => null,
                'key'       => 'classifieds.subcategory.subcategory.key',
                'name'      => 'Some name',
                'value'     => 'Some value',
                'type'      => 'Default',
                'control'   => 'text',
            ],
            */
        ]);
    }
}
