<?php

namespace Classifieds\Subcategory\Http\Controllers;

use App\Http\Controllers\Controller as BaseController;
use Exception;
use Classifieds\Subcategory\Http\Requests\SubcategoryActionsRequest;
use Classifieds\Subcategory\Actions\SubcategoryActions;

/**
 * Admin web controller class.
 */
class SubcategoryActionsController extends BaseController
{

    /**
     * Action controller function for subcategory.
     *
     * @param Model $model
     * @param action next action for the model.
     *
     * @return Response
     */
    public function __invoke(SubcategoryActionsRequest $request, $action)
    {
        try {
            $subcategory = SubcategoryActions::run($request, $action);
            return $this->response->message(trans('messages.success.updated', ['Module' => trans('subcategory::subcategory.name')]))
                ->code(204)
                ->data(compact('data'))
                ->status('success')
                ->url(guard_url('subcategory/subcategory/' . $action))
                ->redirect();
        } catch (Exception $e) {
            return $this->response->message($e->getMessage())
                ->code(400)
                ->status('error')
                ->url(guard_url('subcategory/subcategory/' . $action))
                ->redirect();
        }
    }
}
