<?php
namespace Classifieds\Subcategory\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Notifications\Notification;
use Classifieds\Subcategory\Events\SubcategoryAction as SubcategoryActionEvent;
use Classifieds\Subcategory\Models\Subcategory;

class SubcategoryAction extends Notification implements ShouldQueue
{
    use Queueable;

    protected $event;
    protected $subcategory;
    protected $action;
    protected $request;

    /**
     * Create a new notification instance.
     *
     * @param SubcategoryActionEvent $subcategory
     */
    public function __construct(SubcategoryActionEvent $subcategory)
    {
        $this->action = $event->action;
        $this->subcategory = $subcategory;
        $this->request = $event->request;
        $this->event = $event;

    }

    /**
     * Get the mail representation of the notification.
     *
     * @param mixed $notifiable
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        return (new MailMessage)
            ->subject('Subcategory Approved - ' . config('app.name'))
            ->view('subcategory::subcategory.email.action', ['data' => $this->subcategory]);
    }

    /**
     * Get the notification's delivery channels.
     *
     * @param object $notifiable
     * @return array<int, string>
     */
    public function via(object $notifiable): array
    {
        return ['mail'];
    }
}
