<?php

namespace Classifieds\Subcategory\Policies;

use Classifieds\Subcategory\Models\Subcategory;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait SubcategoryAction
{

    /**
     * Determine if the given user can copy the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function copy(Authenticatable $user, Subcategory $subcategory)
    {

        if ($authUser->canDo('subcategory.subcategory.action.copy')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can empty the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    function empty(Authenticatable $user, Subcategory $subcategory) {

        if ($authUser->canDo('subcategory.subcategory.action.empty')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can transfer the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function transfer(Authenticatable $user, Subcategory $subcategory)
    {

        if ($authUser->canDo('subcategory.subcategory.action.transfer')) {
            return true;
        }

        $this->model->is_owner;
    }

}
