<?php

namespace Classifieds\Subcategory\Policies;

use Classifieds\Subcategory\Models\Subcategory;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait SubcategoryWorkflow
{

    /**
     * Determine if the given user can approve the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function approve(Authenticatable $user, Subcategory $subcategory)
    {
        if ($user->canDo('subcategory.subcategory.approve')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function submit(Authenticatable $user, Subcategory $subcategory)
    {
        if ($user->canDo('subcategory.subcategory.submit')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function publish(Authenticatable $user, Subcategory $subcategory)
    {
        if ($user->canDo('subcategory.subcategory.publish')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function unpublish(Authenticatable $user, Subcategory $subcategory)
    {
        if ($user->canDo('subcategory.subcategory.unpublish')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function archive(Authenticatable $user, Subcategory $subcategory)
    {
        if ($user->canDo('subcategory.subcategory.archive')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function unarchive(Authenticatable $user, Subcategory $subcategory)
    {
        if ($user->canDo('subcategory.subcategory.unarchive')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given subcategory.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function reject(Authenticatable $user, Subcategory $subcategory)
    {
        if ($user->canDo('subcategory.subcategory.reject')) {
            return true;
        }

        return false;
    }

}
